% Map data value to color.
%
% function color = map_data (self, v)
%
% v= data value
% Call as:
% c=field(struct ('name', ['c'], 'data', map_data(dcm, Uz)));

function color = map_data (self, v)
    n = length(v);
    color = ones(n,3)*0.5;
    if (self.rmax > self.rmin)
        for i = 1:n
            k = fix(((v(i)-self.rmin)/(self.rmax-self.rmin))*(self.ncolors-1))+1;
            if k >= 1 & k<=size(colormap,1)
                color(i,:) = self.colormap(k,:);
            else
                if k < 1 & k<=size(colormap,1)
                    color(i,:) = self.colormap(1,:);
                else % k>size(colormap,1)
                    color(i,:) = self.colormap(1,end);
                end
            end
        end
    end
    return;
end
