% Utilities
%
% Toolbox paths:
%   sofea_path                  - returns the SOFEA path
%   sofea_work_path             - returns the SOFEA work folder path
% 
% Browsing of toolbox objects:
%   OB                          - The object browser helper function.
%   OBgui                       - The object browser GUI.
%   ars6                        - Array spreadsheet-like viewer.
%
% Graphics:
%   progressbar                 - Display a status/progress bar and inform about the elapsed
%   savefig                     - Save a figure as an image.
%   show_field_as_arrows        - Display a field using arrows.
%   streamplot                  - Display stream plot
%   sphereplot                  - Same usage as odeplot().
%   tilefigs                    - Tile Matlab figures
%   tricontour                  - Contouring for functions defined on triangular meshes
%   view3d                      - Interactively rotate, zoom and pan the view of a 3-D plot
% 
% General utilities:
%   convert                     - Convert between units from different systems.
%   default_Rm                  - Compute transformation matrix describing local material directions.
%   highlight                   - Produce a latex digest of a function with highlighting.
%   gaussquad                   - Gaussian quadrature integration.
%   geniso_Rm                   - Compute transformation matrix describing local material directions.
%   nd_Rm                       - Compute transformation matrix describing local material directions.
%   richextrapol                - Richardson extrapolation. This function is applicable only to fixed ratio
% 
% Utilities for 3-D rotation dynamics:
%   cayley                      - Cayley transform matrix
%   dexp                        - Derivative of the exponential map.
%   dexpdot                     - Time derivative
%   dexpinv                     - Inverse of the Derivative of the
%                                 exponential map.
%   reortho                     - Re-orthogonalize rotation Matrix.
%   rotmat2rotvec               - Convert rotation matrix R to rotation vector V
%   rotmat                      - Matrix exponential: R = expm(thetatilde);
%   skewmat                     - Create a skew 3x3 Matrix
% 
